Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java	(revision 536)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/editors/ChartEditorPart.java	(revision 537)
@@ -132,97 +132,11 @@
 	public void createPartControl(Composite parent) {
 		super.createPartControl(parent);
 		
-//		// to hide and display the command and rendering parameters composite
-//		this.initParentLayout(parent, 2);
-//		
-//		this.topToolBar = new TXMEditorToolBar(parent, SWT.FLAT, "top", this);
-//		
-//		
-//		GridData gd2 = new GridData();
-//		gd2.grabExcessHorizontalSpace = false;
-//		this.topToolBar.setLayoutData(gd2);
-//		//this.toolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
-//		
-		
 		// Toolbar
 		this.chartToolBar = new ChartEditorToolBar(this.getTopToolBarContainer(), SWT.FLAT | SWT.RIGHT, this);
 		//this.chartToolBar = new ChartEditorToolBar(this.topToolBar, SWT.FLAT | SWT.RIGHT, this);
 		//this.chartToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
 
-		
-		// Tests with groups instead of tabs 
-		// FIXME: command parameters composite
-//		this.computingParametersGroup = new Composite(parent, SWT.NONE);
-//		this.commandParametersGroup = this.initCommandParametersGroup(2);
-//		this.commandParametersGroup.pack();
-
-		
-//		// FIXME: Tab folder tests
-//		final TabFolder tabFolder = new TabFolder(parent, SWT.TOP);
-//		GridData gd1 = new GridData();
-//		tabFolder.setLayoutData(gd1);
-//		gd1.exclude = true;
-//		tabFolder.setVisible(false);
-//		
-//		// Command parameters
-//		TabItem tabItem2 = new TabItem(tabFolder, SWT.NULL);
-//		tabItem2.setText("Command parameters");
-//		this.commandParametersComposite = new Composite(tabFolder, SWT.NONE);
-//		RowLayout layout2 = new RowLayout();
-//		layout2.marginLeft = 10;
-//		layout2.marginTop = 10;
-//		layout2.spacing = 8;
-//		layout2.wrap = true;
-//		layout2.center = true;
-//		this.commandParametersComposite.setLayout(layout2);
-//		tabItem2.setControl(this.commandParametersComposite);
-//
-//		// Charts rendering advanced tool bar
-//		TabItem tabItem = new TabItem(tabFolder, SWT.NULL);
-//		tabItem.setText("Charts rendering");
-//		this.advancedToolBar = new AdvancedChartEditorToolBar(tabFolder, SWT.FLAT, this);
-//		tabItem.setControl(this.advancedToolBar);
-////		this.advancedToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
-//		
-//		
-//		// FIXME: tests show/hide computing parameters
-//		final ToolItem showParameters = new ToolItem(this.toolBar, SWT.CHECK);
-//		showParameters.setImage(IImageKeys.getImage(this, "platform:/plugin/org.txm.rcp/icons/add.png"));
-//		showParameters.setToolTipText("Show/hide advanced parameters");
-//		showParameters.setSelection(false);
-//		
-//		showParameters.addSelectionListener(new SelectionListener() {
-//			
-//			@Override
-//			public void widgetSelected(SelectionEvent e) {
-//				
-//				
-//				((GridData)tabFolder.getLayoutData()).exclude = !showParameters.getSelection();
-//				tabFolder.setVisible(showParameters.getSelection());
-//				tabFolder.getParent().layout(true);
-//			}
-//			
-//			@Override
-//			public void widgetDefaultSelected(SelectionEvent e) {
-//				// TODO Auto-generated method stub
-//				
-//			}
-//		});
-//		
-//		// adapt the height of the tab folder to current tab height
-//		tabFolder.addSelectionListener(new SelectionAdapter() {
-//			@Override
-//			public void widgetSelected(SelectionEvent event) {
-//				tabFolder.getSelection()[0].getControl().pack(true);
-//				System.out.println("ChartEditorPart.createPartControl(...).new SelectionAdapter() {...}.widgetSelected(): current tab bounds " + tabFolder.getSelection()[0].getControl().getBounds());
-//				//tabFolder.setBounds(tabFolder.getBounds().x, tabFolder.getBounds().y, tabFolder.getBounds().width, tabFolder.getSelection()[0].getControl().getBounds().height * 2);
-//				//tabFolder.layout(true);
-//				//tabFolder.pack();
-//			}
-//		});
-
-		//new ToolItem(this.chartToolBar, SWT.SEPARATOR);
-		
 		// Advanced tool bar
 		//this.advancedToolBarComposite = new Composite(parent, SWT.NONE);
 		Group group = this.topToolBar.installGroup("Rendering parameters", "Show/Hide rendering parameters", "platform:/plugin/org.txm.chartsengine.rcp/icons/show_rendering_parameters.png", false);
@@ -255,13 +169,202 @@
 		//this.composite.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
 		//parent.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_WHITE));
 
+//		// FIXME: tests
+//		if(!this.getResultData().isChartDirty())	{
+//
+//			loadChart();
+//			
+//			// Initialize Swing/AWT events delegation.
+//			this.getSite().getShell().getDisplay().syncExec(new Runnable() {
+//				@Override
+//				public void run() {
+//					// initialize the default shared context menus as Export, etc.
+//					initDefaultContextMenus();;
+//	
+//					
+//					// registers user entries event call back extensions
+//					registerEventCallBackExtensions();
+//					
+//					//FIXME: test to contribute to menu only in some context
+//					// create chart editor part context
+//	//				IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+//	//				contextService.activateContext(ChartEditorPart.class.getName());
+//	//				// create chart composite context
+//	//				contextService.activateContext(this.chartComposite.getClass().getName());
+//					
+//					//FIXME: description test
+//					//this.setContentDescription("details");
+//					//this.setContentDescription(this.getResultData().getDetails());
+//	
+//					initializeAWTDelegationListeners();
+//				}
+//			});
+//			
+//			this.refresh();
+//
+//		}
 		
-		this.computeChart(false);
+	}
+
+
+	/**
+	 * Initializes the default context menus.
+	 */
+	public void initDefaultContextMenus()	{
+		SWTChartsComponentsProvider.initDefaultContextMenus(this.chartComposite);
+	}
+	
+	
+	/**
+	 * Computes and creates or updates the char (from the linked editor input data)t.
+	 * @param update set if it's an update of an existing chart or a creation of a new chart
+	 */
+	public void computeChart(boolean update) {
+		this.computeChart(update, false, false);
+	}
+	
+	
+	/**
+	 * Computes and creates or updates the chart (from the linked editor input data).
+	 * @param jobName
+	 * @param update set if it's an update of an existing chart or a creation of a new chart
+	 * @param setUser if true, the progression bar dialog will be visible otherwise it will be reduced at bottom right status bar area.
+	 * @param resetView
+	 * @param clearChartItemsSelection
+	 */
+	public void computeChart(final boolean update, final boolean resetView, final boolean clearChartItemsSelection) {
+		compute(this.getResultData(), update, this, SWTChartsComponentsProvider.getCurrent(), resetView, clearChartItemsSelection);
+	}
+
+
+	
+	public static void compute(final ChartResult result)	{
+		compute(result, SWTChartsComponentsProvider.getCurrent());
+	}
+	
+	public static void compute(final ChartResult result, SWTChartsComponentsProvider chartsComponentsProvider)	{
+		compute(result, false, null, chartsComponentsProvider, false, false);
+	}
+	
+	/**
+	 * 
+	 * @param result
+	 * @param update
+	 * @param editor
+	 * @param chartsComponentsProvider
+	 * @param resetView
+	 * @param clearChartItemsSelection
+	 */
+	public static void compute(final ChartResult result, final boolean update, final ChartEditorPart editor, final SWTChartsComponentsProvider chartsComponentsProvider, final boolean resetView, final boolean clearChartItemsSelection)	{
 		
-		
-		
+		JobHandler job = new JobHandler("Computing result") {
+
+			ChartEditorPart editor2 = editor;
+			
+		    @Override
+		    protected IStatus run(IProgressMonitor monitor) {
+
+		    	this.runInit(monitor);
+		    	
+		    	try {
+
+		    		// computing result
+					monitor.beginTask("Computing", 100);
+
+					// FIXME: to restore when implemented
+//					if(!update)	{
+//						result.loadParameters();
+//					}
+					
+					if(result.compute(update, monitor))	{
+						monitor.worked(25);
+						
+						// creating/updating chart
+						result.computeChart(update);
+						monitor.worked(50);
+					}
+
+					// cancel
+					if(monitor.isCanceled())	{
+						return Status.CANCEL_STATUS;
+					}
+
+					// opening editor if not exists
+					if(editor2 == null)	{
+						this.syncExec(new Runnable() {
+							@Override
+							public void run() {
+								editor2 = chartsComponentsProvider.openEditor(result);
+							}
+						});
+					}
+					
+					// loading chart
+					monitor.subTask("loading chart");
+					editor2.loadChart(resetView, clearChartItemsSelection);
+
+					// if editor wasn't exist:
+					// hiding command parameters, updating tool bar buttons states, registering context menus and event user callbacks 
+					if(!update && !editor2.getResultData().isChartDirty())	{
+						this.syncExec(new Runnable() {
+							@Override
+							public void run() {
+								// FIXME: decide if we automatically hide or not the parameter area
+								//editor2.getTopToolbar().setComputingParametersVisible(false);
+								
+								// FIXME: tests to disable command if the chart is null and reenable it when the chart is computed 
+								//editor2.getChartToolBar().synchronize();
+								
+								// initialize the default shared context menus as Export, etc.
+								editor2.initDefaultContextMenus();
+						
+								// registers user entries event call back extensions
+								editor2.registerEventCallBackExtensions();
+								
+								//FIXME: test to contribute to menu only in some context
+								// create chart editor part context
+				//				IContextService contextService = (IContextService)getSite().getService(IContextService.class);
+				//				contextService.activateContext(ChartEditorPart.class.getName());
+				//				// create chart composite context
+				//				contextService.activateContext(this.chartComposite.getClass().getName());
+								
+								//FIXME: description test
+								//editor2..setContentDescription("details");
+								//editor2..setContentDescription(this.getResultData().getDetails());
+				
+								editor2.initializeAWTDelegationListeners();
+							}
+						});
+					}
+						
+
+					// refreshing the tree node
+					if(editor2 != null)	{
+						editor2.refresh();
+					}
+					
+					// done
+					monitor.done();
+				}
+		    	// for user direct canceling
+		    	catch(ThreadDeath td) {
+		    		// FIXME should clean() and/or set the result as dirty?
+		    		return Status.CANCEL_STATUS;
+		    	}
+				catch(Exception e) {
+					// TODO Auto-generated catch block
+					e.printStackTrace();
+				} 
+				return Status.OK_STATUS;
+		    }
+
+		};
+		job.setPriority(Job.DECORATE);
+		job.setUser(false);
+		job.schedule();
 	}
 
+	
 
 	/**
 	 * Registers user entries event call back extensions.
@@ -366,165 +469,9 @@
 	}
 
 	
-
 	
-	/**
-	 * Computes and creates or updates the char (from the linked editor input data)t.
-	 * @param update set if it's an update of an existing chart or a creation of a new chart
-	 */
-	public void computeChart(boolean update) {
-		this.computeChart(update, false, false);
-	}
-	
-	
-	/**
-	 * Computes and creates or updates the chart (from the linked editor input data).
-	 * @param jobName
-	 * @param update set if it's an update of an existing chart or a creation of a new chart
-	 */
-	public void computeChart(String jobName, boolean update) {
-		this.computeChart(jobName, update, false, false, false);
-	}
 
-	
 	/**
-	 * Computes and creates or updates the chart (from the linked editor input data).
-	 * @param update set if it's an update of an existing chart or a creation of a new chart
-	 * @param resetView
-	 * @param clearChartItemsSelection
-	 */
-	public void computeChart(boolean update, boolean resetView, boolean clearChartItemsSelection) {
-		this.computeChart("Computing chart", update, false, resetView, clearChartItemsSelection);
-	}
-	
-	/**
-	 * Computes and creates or updates the chart (from the linked editor input data).
-	 * @param jobName
-	 * @param update set if it's an update of an existing chart or a creation of a new chart
-	 * @param setUser
-	 */
-	public void computeChart(String jobName, boolean update, boolean setUser) {
-		this.computeChart(jobName, update, setUser, true, true);
-	}
-	
-	/**
-	 * Computes and creates or updates the chart (from the linked editor input data).
-	 * @param jobName
-	 * @param update set if it's an update of an existing chart or a creation of a new chart
-	 * @param setUser if true, the progression bar dialog will be visible otherwise it will be reduced at bottom right status bar area.
-	 * @param resetView
-	 * @param clearChartItemsSelection
-	 */
-	public void computeChart(String jobName, final boolean update, boolean setUser, final boolean resetView, final boolean clearChartItemsSelection) {
-		
-		
-		JobHandler job = new JobHandler(jobName) {
-
-		    @Override
-		    protected IStatus run(IProgressMonitor monitor) {
-
-		    	this.runInit(monitor);
-		    	
-		    	try {
-
-		    		// computing result
-					monitor.beginTask("Computing", 100);
-
-		    		// FIXME: temporary solution, should call super.computeResult() ?
-					if(getResultData().isDirty())	{
-						getResultData().compute(update, monitor);
-					}
-		    		
-					
-					// creating/updating chart
-					monitor.subTask("computing chart");
-
-					getResultData().computeChart(update);
-
-					if(!update)	{
-						createChartContainer();
-					}
-
-					// FIXME: long process test
-//					for(long i = 0; i < 9000000000L; i++)	{
-//						;
-//					}
-
-					monitor.worked(25);
-					
-					// cancel
-					if(monitor.isCanceled())	{
-						close(true);
-						return Status.CANCEL_STATUS;
-					}
-					
-					// loading
-					monitor.subTask("loading chart");
-					loadChart(resetView, clearChartItemsSelection);
-
-					if(!update)	{
-						// Initialize Swing/AWT events delegation.
-						this.syncExec(new Runnable() {
-							@Override
-							public void run() {
-								// initialize the default shared context menus as Export, etc.
-								SWTChartsComponentsProvider.initDefaultContextMenus(chartComposite);
-
-								
-								// registers user entries event call back extensions
-								registerEventCallBackExtensions();
-								
-								//FIXME: test to contribute to menu only in some context
-								// create chart editor part context
-//								IContextService contextService = (IContextService)getSite().getService(IContextService.class);
-//								contextService.activateContext(ChartEditorPart.class.getName());
-//								// create chart composite context
-//								contextService.activateContext(this.chartComposite.getClass().getName());
-								
-								//FIXME: description test
-								//this.setContentDescription("details");
-								//this.setContentDescription(this.getResultData().getDetails());
-
-								initializeAWTDelegationListeners();
-							}
-						});
-					}
-
-					
-					// FIXME: refresh the tree node
-//				getSite().getShell().getDisplay().syncExec(new Runnable() {
-//					@Override
-//					public void run() {
-							refresh();
-//					}
-//				});
-
-					
-					// done
-					monitor.done();
-				}
-		    	// for user direct canceling
-		    	catch(ThreadDeath td) {
-		    		// FIXME should clean() and/or set the result as dirty?
-		    		close(true);
-		    		return Status.CANCEL_STATUS;
-		    	}
-				catch(Exception e) {
-					// TODO Auto-generated catch block
-					e.printStackTrace();
-				} 
-				return Status.OK_STATUS;
-		    }
-
-		};
-		job.setPriority(Job.DECORATE);
-		job.setUser(setUser);
-		job.schedule();
-	}
-
-
-
-	/**
 	 * Initialize Swing/AWT events delegation.
 	 * @param swingComponent
 	 */
@@ -897,16 +844,6 @@
 
 
 	/**
-	 * Opens an editor for the specified result.
-	 * @param result
-	 * @return
-	 */
-	public static ChartEditorPart openEditor(ChartResult result)	{
-		return SWTChartsComponentsProvider.getCurrent().openEditor(result);
-	}
-	
-
-	/**
 	 * Checks whatever the chart composite has the focus or not.
 	 * @return <code>true</code> if the chart composite has the focus otherwise <code>false</code>
 	 */
@@ -934,4 +871,13 @@
 	public ChartComposite getChartComposite() {
 		return chartComposite;
 	}
+
+
+
+	/**
+	 * @return the chartToolBar
+	 */
+	public ChartEditorToolBar getChartToolBar() {
+		return chartToolBar;
+	}
 }
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java	(revision 536)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/ChartEditorToolBar.java	(revision 537)
@@ -1,7 +1,12 @@
 package org.txm.chartsengine.rcp.swt;
 
+import org.eclipse.core.commands.Command;
 import org.eclipse.swt.widgets.Composite;
+import org.eclipse.ui.PlatformUI;
+import org.eclipse.ui.commands.ICommandService;
+import org.eclipse.ui.handlers.IHandlerService;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
+import org.txm.chartsengine.rcp.handlers.ExportChartEditorView;
 import org.txm.rcp.editors.TXMEditorToolBar;
 
 /**
@@ -36,6 +41,7 @@
 	public ChartEditorToolBar(Composite parent, int style, ChartEditorPart chartEditorPart) {
 		this(parent, style, "ChartEditorToolBar", chartEditorPart); //$NON-NLS-1$
 
+		
 		//FIXME: tests
 //		new ToolItem(this, SWT.SEPARATOR);
 //		
@@ -171,7 +177,35 @@
 //		showGrid.addSelectionListener(listener);
 	}
 
+	
+	/**
+	 * Synchronizes the tool bar with the chart result states.
+	 * Enables/disables button according to the chart result states.
+	 * 
+	 */
+	// FIXME: tests to disable command if the chart is null and reenable it when the chart is computed 
+//	public void synchronize()	{
+//		boolean enable = (this.getEditorPart().getResultData().getChart() != null);
+////		HandledContributionItem t = (HandledContributionItem) this.getItem(0).getData();
+//		System.out.println("ChartEditorToolBar.synchronize()");
+//		
+//		IHandlerService handlerService = (IHandlerService) PlatformUI.getWorkbench().getService(IHandlerService.class);
+//        ICommandService commandService = (ICommandService) PlatformUI.getWorkbench().getService(ICommandService.class);
+//        if (handlerService != null && commandService != null) {
+//                try {
+//                        Command command = commandService.getCommand(ExportChartEditorView.ID);
+//                        command.setEnabled(null);
+//                        //command.setEnabled(new Boolean(enable));
+//                } catch (Exception e) {
+//                	e.printStackTrace();
+//                }
+//        }
+//        else	{
+//        	System.err.println("ChartEditorToolBar.synchronize() can't get handler service");
+//        }
+//	}
 
+
 	@Override
 	public ChartEditorPart getEditorPart() {
 		return (ChartEditorPart) editorPart;
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java	(revision 536)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/swt/AdvancedChartEditorToolBar.java	(revision 537)
@@ -238,9 +238,10 @@
 					update = false;
 				}
 
+				chartEditorPart.getResultData().setChartDirty();
 				
-				// updates existing chart
-				chartEditorPart.computeChart("Update chart", update);
+				// updates or creates chart
+				chartEditorPart.computeChart(update);
 			}
 			
 			@Override
@@ -259,6 +260,4 @@
 	}
 
 
-
-
 }
Index: tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/handlers/ExportChartEditorView.java
===================================================================
--- tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/handlers/ExportChartEditorView.java	(revision 536)
+++ tmp/org.txm.chartsengine.rcp/src/org/txm/chartsengine/rcp/handlers/ExportChartEditorView.java	(revision 537)
@@ -31,9 +31,12 @@
 import java.io.IOException;
 //import java.nio.file.Files;
 
+
+
 import org.eclipse.core.commands.AbstractHandler;
 import org.eclipse.core.commands.ExecutionEvent;
 import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.commands.IHandler2;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Status;
@@ -63,11 +66,19 @@
  * @author sjacquot
  *
  */
-public class ExportChartEditorView extends AbstractHandler {
+public class ExportChartEditorView extends AbstractHandler implements IHandler2 {
 
 	public static final String ID = "org.txm.chartsengine.rcp.handlers.ExportChartEditorView"; //$NON-NLS-1$
 
-
+	// FIXME: tests to disable command if the chart is null and reenable it when the chart is computed 
+//	public boolean isEnabled() {
+//		return false;
+//	}
+//	public void setEnabled(Object evaluationContext) {
+//		System.out.println("ExportChartEditorView.setEnabled()");
+//		//System.out.println("ExportChartEditorView.setEnabled(): " + evaluationContext);
+//		this.setBaseEnabled(false);
+//	}
 	
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
Index: tmp/org.txm.chartsengine.rcp/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.chartsengine.rcp/META-INF/MANIFEST.MF	(revision 536)
+++ tmp/org.txm.chartsengine.rcp/META-INF/MANIFEST.MF	(revision 537)
@@ -12,7 +12,8 @@
  org.txm.rcp;bundle-version="0.7.8",
  org.eclipse.core.resources,
  org.eclipse.swt,
- org.eclipse.core.expressions;bundle-version="3.4.600"
+ org.eclipse.core.expressions;bundle-version="3.4.600",
+ org.eclipse.e4.ui.workbench.renderers.swt
 Export-Package: org.txm.chartsengine.rcp,
  org.txm.chartsengine.rcp.editors,
  org.txm.chartsengine.rcp.events,
